Subject: RE: bug#24510: 25.1; Info: searching for ` does not find what looks like `

From: Drew Adams <[email-masked]>
Date: Fri, 23 Sep 2016 14:47:12 -0700 (PDT)

> > Why do you insist on saying things like "none of us,
> > including yourself, have actually witnessed it?"
> 
> Because you yourself just said that the characters look
> different to you.

No.  I said clearly that they can easily be mistaken for each
other, even though it is true that they are not _exactly_ the
same visually:

  See attached screenshot.  No, they are not EXACTLY the same.  But
  a user who is used to searching for ` (from the backquote key) in
  such a context can easily think that it IS the same character.
                     ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
  S?he can easily either think (1) that the text s?he (thought s?he
  was) searching for is not present (e.g., if s?he does not see it)
  or (2) that Isearch is not working properly for some reason.

And I said clearly, in the message before that one:

  They look slightly different, yes.  Barely noticeable when
            ^^^^^^^^                  ^^^^^^^^^^^^^^^^^
  you see them side by side (see screenshot).

Barely noticeable EVEN when you see them side by side.
That was my judgment then, and I'm sticking to it now.

  But otherwise not noticeable enough that someone used to Emacs
                ^^^^^^^^^^^^^^^^^^^^^
  < 25.1 would expect that the ` s?he types (as s?he always has,
  for this) does not result in the same character s?he sees as a
  name left delimiter.

And I fell upon this bug by accident, when I tried to do
what the bug recipe describes, with emacs -Q: search for
"`list" in a topic where that text occurs, but with a left
single quotation mark instead of `.

It's a real report of a real experience, with emacs -Q.

You keep trying to show that there is no problem by
referring to the fact that I myself usually use Emacs with
a different font.  But this is not about me.  It's about
the default behavior of Emacs.

I included the screenshot so that you and others can
easily see for yourselves how much the two chars resemble
each other.

OK, so you disagree that they do.  To you it is crystal
clear that they are not the same, and you cannot imagine
that anyone could see things differently.  For you, I'm
making this all up just to bother you, perhaps?

Am I the only one who sees these characters as similar
in appearance, and easy to mistake, one for the other?
Dunno.  But no one need take my word for the appearance,
at least.  The screenshot is there for anyone to check
and come to their own conclusion.

> > > Weren't you one of those who lobbied for turning the character-folding
> > > off by default?  If it were not for that lobbying, your search would
> > > have succeeded.
> >
> > No.  And there was no such "lobbying", by anyone.  Can you point
> > to any post by me, in the long and deep discussion about this on
> > emacs-devel ("On language-dependent defaults for character-folding")
> > where I did that?
> 
> You just did it yourself, so I can rest my case.

Is this really the way you try to reason, and discuss something?

You apparently cannot show that I lobbied for turning char
folding off by default, so you resort to claiming that I
have argued that just now?  Where?

Are you perhaps watching too much Trump these days?

In fact, I stated clearly in this thread that turning it on,
at least for quotation, could be one of the possible fixes
for this bug.

My position on the default has been, from the beginning
(in case you are really interested, though it is _irrelevant_
for this bug report), is that the default behavior is not
very important.

And that what is more important is that users (1) be able
to easily customize the behavior, (2) be able to toggle it
during isearch, and (3) be told about it in clear terms
(especially if the default behavior represents a change),
in both the doc and the NEWS.

THAT was my point of view during the default discussion.
And it has not changed.

However, now that I have come across this usability bug,
I think the bug should be fixed.  But the default behavior
is still less important that what I argued for.

IF you choose to fix the bug by changing the default
behavior for folding quotes, that will be better, I think,
than not fixing it.

I'm hoping that there might be a better fix available.
I'm hoping that someone will come up with something good.
But you've rejected the only other one I've come up with:
change the default font, to avoid the similarity of appearance.

> > And why would it be important if I had?  Are you trying to
> > mete out punishment, saying that it is my fault that Emacs
> > now presents, by default, a visual confusion of single-quoting?
> 
> I'm saying that yours are double standards.

Show us, please.  What _are_ you talking about?

Better yet, please address the bug, and not just attack the
messenger.

> > > The look quite different to me (my system uses the same font),
> >
> > You _know_ they are different.  Please look again at the screenshot
> > I sent, and imagine that it does not include the window showing the
> > two right next to each other, so you see what a user sees when s?he
> > searches for `.
> 
> I did.  They still look different.

OK.  Clearly you have good eyes.

But even with your good eyes you cannot see that someone (else)
could easily mistake one for the other?   Especially since s?he
has long been able to search for quoted names using `?  You can't
see a problem here for others, even if you yourself have no such
problem?

> > > I'm not dismissing the problem.  I'm saying that I don't see a
> > > solution except through user customizations.  Searching for similarly
> > > looking characters is not specific to Info, it can happen elsewhere.
> > > Users who bump into that frequently should customize their fonts
> > > and/or turn on character-folding in search commands.
> >
> > That's not a solution for the default behavior, which is what
> > this bug is about.  If that is what you propose to solve the
> > problem here then you are indeed dismissing the problem.
> 
> Customizations exist in Emacs for a reason.  Saying that every problem
> must be solved in "emacs -Q" is absurd, especially for minor problems
> such as this one, with 2 characters that look differently.

Another straw-man argument.  Did someone argue that every
problem must be solved in "emacs -Q"?  No, of course not.

> > Two possible solutions have been suggested in this thread, so far:
> >
> > 1) Emacs can try to avoid using Courier New as the default font.
> 
> Not an option.  Other fonts have much less coverage, and most of them
> are much uglier.  You may wish looking at them before you suggest
> this.

I'm no expert on fonts.  Are you speaking authoritatively,
about ALL other fonts, when you say "other fonts"?

I can't argue about coverage (I don't use RTL or many
non-English characters, personally).  And I won't try to
argue about what is ugly or not.  For English, I can offer
the font I use as one that I find useful for MS Windows,
FWIW: Lucida Console.  I don't claim that it could or
should be adopted by Emacs.

Do we have a prioritized list of the important qualities
of a default font for Emacs?  How important is "coverage",
and just what do we mean by it?  How important is visual
distinction/confusion of characters (including letters vs
numbers)?

Again, the default font is not the most important thing.
It need not be perfect.  But it can help or hinder
understanding of Emacs, including by searching for
information.

> > 2. Isearch can fold "single-quote" chars (i.e., chars that could
> >    be confused in this regard), by default.
> 
> I'm okay with that, but my opinions on that were overruled.
> 
> > Please note, BTW, that I have _not_ opposed #2, just as I did
> > _not_ "lobby for turning the character-folding off by default"
> > during the general emacs-devel discussion.
> 
> Sure, you did.  You just prefer to deny it now.

See above.  Including my citing #2, from the beginning,
as one possible fix for this bug.  And note your lack
of finding any post by me where I lobbied to turn off
folding by default.

And I spent time looking through the thread, to see
what people, including you and me, actually said there.
Please put some evidence where your claims are.

Or is it perhaps that you were alone in being _adamant_
about turning it on by default, so that even those who
were on the fence about the default behavior have now
been put on your enemies list and must be thoroughly
castigated?

> > What's not helpful is dismissing the problem or casting
> > blame for it.
> 
> I agree.  Do you realize that this is what you are doing?

Uh, how so, Eli?  Have I blamed you for this bug?  No way.

You, on the other hand _have_:

* dismissed the problem, saying that there can be
  no difficulty distinguishing the characters.

* blamed me for the default search behavior of not
  character-folding.